var treeView = {
    rowCount : 0,
    items:[],
	getCellText : function(row,column){
		switch (column.id) {
			case 'fname': return this.items[row].name;
			case 'fvalue': return this.items[row].value;
			default: return column.id;
		}
	},
    insertItem : function(item){
		try	{
		    this.items.push(item);
		    this.treebox.rowCountChanged(this.rowCount, 1);
		}
		catch (err)	{alert(err);}
	},
	getItem: function (row) { return this.items[row] },
	updateItem: function (row,item) { this.items[row]=item; },
	deleteItem: function (row) {
		this.items.splice(row,1);
		this.treebox.rowCountChanged(this.rowCount, -1);
	},
	invalidate: function(){this.treebox.invalidate();},
	cycleHeader: function () {},

    setTree: function(treebox){ this.treebox = treebox; },
    isContainer: function(row){ return false; },
    isSeparator: function(row){ return false; },
    isSorted: function(){ return false; },
    getLevel: function(row){ return 0; },
    getImageSrc: function(row,col){ return null; },
    getRowProperties: function(row,props){},
    getCellProperties: function(row,col,props){},
    getColumnProperties: function(colid,col,props){}
};

var result;

function onLoad() {
	result=window.arguments[0];
	var tree=document.getElementById('aftree'),n=0;
	tree.view=treeView;
	for (var i in result) {
		treeView.insertItem({name:i,value:result[i]});
		delete result[i];
	}
}

function onDialogAccept() {
	var item;
	for (var i in treeView.items) {
		item=treeView.items[i];
		result[item.name]=item.value;
	}
	return true;
}

function mfuAddEditWindow(name,value) {
	name=name?name:'';
	value=value!=null?value:'';
	var arg={name:name,value:value}
	var win = window.openDialog("chrome://uploader/content/addeditfield.xul",
		"Add/Edit Field","chrome,centerscreen,modal",arg);
	return arg;
}

function mfuAddField() {
	var arg=mfuAddEditWindow();
	if (arg.name) treeView.insertItem(arg);
}

function mfuDelField() {
	var index=treeView.selection.currentIndex
	if (index>=0) {
		treeView.deleteItem(index);
		treeView.invalidate();
	}
}

function mfuEditField() {
	var index=treeView.selection.currentIndex;
	if (index>=0) {
		var item = treeView.getItem(index);
		var arg=mfuAddEditWindow(item.name,item.value);
		if (arg.name) {
			treeView.updateItem(index,arg);
			treeView.invalidate();
		}
	}
}
