function mfuProfile (name) {
	this.name=name;
	this.url='';
	this.fields=[];
	this.lockUrl=false;
	this.choose=false;
	this.namingTemplate='file%d';
	this.namingFirstN=1;
}

mfuProfile.prototype={
	_loadSetting: function(name,type) {
		var s=null;
		try {s=mfuGetSetting('profiles.'+this.name+"."+name,type);} catch(e) { dump(e) }
		return s;
	},
	_saveSetting: function(name,value) {
		mfuSetSetting('profiles.'+this.name+"."+name,value);
	},
	load: function (name) {
		if (name) this.name=name;
		this.url=this._loadSetting('url','string');
		this.url=this.url?this.url:'';
		this.namingTemplate=this._loadSetting('template','string');
		this.namingFirstN=this._loadSetting('firstn','number');
		this.filter=this._loadSetting('filter','string');
		this.namingTemplate=this.namingTemplate?this.namingTemplate:'file%d';
		this.namingFirstN=this.namingFirstN?this.namingFirstN:0;
		var childs=mfuPrefChilds('profiles.'+this.name+".fields"),i;
		this.fields=[];
		for (i in childs) this.fields.push({name:childs[i],value:this._loadSetting("fields."+childs[i],'string')});
	},
	save: function () {
		var prefs = mfuGetPrefBranch("profiles."+this.name),i;
		prefs.deleteBranch('fields');
		this._saveSetting("url",this.url);
		this._saveSetting("template",this.namingTemplate);
		this._saveSetting("firstn",this.namingFirstN);
		this._saveSetting("filter",this.filter);
		for (i in this.fields) this._saveSetting("fields."+this.fields[i].name,this.fields[i].value);
	},
	deleteByName: function (name) {
		//dump ("deleting: "+name);
		if (name=='default') return false;
		var prefs = mfuGetPrefBranch("profiles."+name),i;
		prefs.deleteBranch('');
		return true;
	},
	saveAs: function (name) {

	},
	redraw: function () {
		var btn=document.getElementById('afbtn');
		if (/.*\s\(\d{1,2}\)/.test(btn.label)) btn.label=btn.label.replace(/\d{1,2}/,this.fields.length);
		else btn.label+=(" ("+this.fields.length+")");

		var cururl=mfuGetCurrentWindowUrl();
		document.getElementById('uploadurl').value=this.url;
		document.getElementById('getcurrent').disabled=this.url==cururl;
		document.getElementById('filefilter').value=this.filter;
	},
	profileList: function() {
		var childs=mfuPrefChilds('profiles'),i,pp,result=[];
		for (i in childs) {
			pp=childs[i].indexOf('.');
			childs[i]=pp!=-1?childs[i].substr(0,pp):childs[i];
			if (result.indexOf(childs[i])==-1) result.push(childs[i]);
		}
		return result;
	}
}

var tprofile;

function onLoad() {
	var pname,cr=true,l,e,pl,si;
	try {pname=mfuGetSetting('profile.last','string');}
	catch(e){pname='default';cr=false}
	tprofile = new mfuProfile(pname);
	if (cr) tprofile.load();
	else tprofile.save();
	tprofile.redraw();
	try {l=mfuGetSetting('profile.lockurl','boolean');}catch(e){l=false;}
	document.getElementById('lockurl').checked=l;
	mfuLockToPage(l);

	// Loading list of profiles
	pl=mfuProfile.prototype.profileList()
	e=document.getElementById('profmenu');
	for (l in pl) { var i=e.appendItem(pl[l]); if (pl[l]==pname) si=i; }
	e.selectedItem=si?si:e.firstChild.firstChild;
	e.addEventListener("ValueChange", mfuOnSelectProfile, false);
	document.getElementById('uploaderTree').view=mfuFileTreeView;
}

function mfuGetCurrent() {
	tprofile.url=mfuGetCurrentWindowUrl();
	tprofile.redraw();
}

function mfuGetCurrentWindowUrl() {
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var recentWindow = wm.getMostRecentWindow("navigator:browser");
	return recentWindow ? recentWindow.content.document.location : 'enter url here';
}

function onDialogAccept() {
	tprofile.url=document.getElementById('uploadurl').value;
	tprofile.save();
	mfuSetSetting('profile.lockurl',document.getElementById('lockurl').checked);
	mfuSetSetting('profile.last',tprofile.name);
	return true;
}

function mfuShowAdditional() {
	var arg={},i;
	for (i in tprofile.fields) arg[tprofile.fields[i].name]=tprofile.fields[i].value;
	var win = window.openDialog("chrome://uploader/content/addfielddlg.xul",
		"Additional Fields","chrome,centerscreen,modal",arg);
	tprofile.fields=[];
	for (i in arg) tprofile.fields.push({name:i,value:arg[i]});
	tprofile.redraw();
}

function mfuSaveProfile() {
	var pl=mfuProfile.prototype.profileList(),
		menu=document.getElementById('profmenu'),
		name=menu.value,
		item;
	tprofile.name=name;
	tprofile.save();
	if (pl.indexOf(name)==-1) { item=menu.appendItem(name); menu.selectedItem=item; }
}

function mfuSelectProfile(name) {

}

function mfuOnSelectProfile(e) {
	tprofile.load(e.selectedItem.label);
	tprofile.redraw();
}

function mfuOnInputUrl(e) {
	document.getElementById('getcurrent').disabled=false;
	tprofile.url=e.value;
}

function mfuOnSelectAll() {
	mfuFileTreeView.selectAll();
}

function mfuDelProfile() {
	var pl=mfuProfile.prototype.profileList(),
		menu=document.getElementById('profmenu'),
		name=menu.value,i,
		child=menu.firstChild.firstChild;
	if (pl.indexOf(name)!=-1&&mfuProfile.prototype.deleteByName(name)) {
		do {
			if (child.label==name) {
				child.parentNode.removeChild(child);
				menu.selectedIndex=0;
				tprofile.load('default');
				break;
			}
		} while ((child=child.nextSibling))
		//for (i in pl) if (pl[i]==name) menu.removeItemAt(i);
	}
}


var mfuFileTreeView={
	rowCount : 0,
	files:[],
	selection:null,
	getCellText : function(row,column){
		switch (column.id) {
			case 'name': return this.files[row].name;
			case 'fieldname': return this.files[row].fieldname;
			case 'path': return this.files[row].path;
			case 'status': return this.files[row].status;
			case 'size': return this.files[row].size.toString().replace(/(\d{1,3}(?=(\d{3})+$))/g,"\$1.");
			case 'dir': return this.files[row].isdir?'yes':'no';
		}
	},
	getCellValue : function(row,column){
		switch (column.id) {
			case 'choose': return this.files[row].choose?true:false;
		}
	},
	setCellValue : function(row,column,value){
		switch (column.id) {
			case 'choose': this.files[row].choose=value=='true';
		}
		mfuFileTreeView.invalidate();
	},
	isEditable:function (row,column) {
		return column.id=='choose';
	},
	selectAll: function () {
		for (var i in this.files) this.files[i].choose=true;
		this.invalidate();
	},
	invalidate : function(){this.treebox.invalidate();},
	insertItem : function(mfuFile){
		try	{
		    this.files.push(mfuFile);
		    this.treebox.rowCountChanged(this.rowCount, 1);
		}
		catch (err)	{alert(err);}
	},
	updateSelectedStatus : function (st) {
		for (var i in this.files) if (this.files[i].choose) this.files[i].status=st;
	},
	cycleHeader: function cycleHeader(aCol) {
		if (typeof aCol != 'string') aCol = aCol.id;
		var treeCol = document.getElementById(aCol);
		if (!treeCol) return;

		var cycle = {
			natural: 'ascending',
			ascending: 'descending',
			descending: 'ascending'};
		var curDirection = 'natural';
		if (this.sortColumn == treeCol)
		curDirection = treeCol.getAttribute('sortDirection');
		else if (this.sortColumn)
		this.sortColumn.removeAttribute('sortDirection');

		curDirection = cycle[curDirection];

		window.mfuSortField=aCol;
		window.mfuCurSortDirection=curDirection;
		try {this.files.sort(this.sortByColumn);}
		catch (e) {alert ('sort error '+e)}


		treeCol.setAttribute('sortDirection', curDirection);
		this.sortColumn = treeCol;

	},
	sortByColumn: function (a,b) {
		var id=window.mfuSortField;
		var c=(a[id]==b[id]?0:(a[id]>b[id]?1:-1));
		return (mfuCurSortDirection=='descending'?-c:c);
	},
	selectionChanged: function() {},
	setTree: function(treebox){ this.treebox = treebox; },
	isContainer: function(row){ return false; },
	isSeparator: function(row){ return false; },
	isSorted: function(){ return (this.sortColumn && this.sortColumn.getAttribute('sortDirection') != 'natural'); },
	getLevel: function(row){ return 0; },
	getImageSrc: function(row,col){ return null; },
	getRowProperties: function(row,props){},
	getCellProperties: function(row,col,props){},
	getColumnProperties: function(colid,col,props){}
}

var mfuFile=function (file) {
	this.path=file.path;
	this.isdir=file.isDirectory() ;
	this.status=0;
	this.size=this.isdir?0:file.fileSize;
	this.name=file.leafName;
	this.fieldname='';
}

function mfuChooseAndShowFiles(files) {
	var n=tprofile.namingFirstN,filter=document.getElementById('filefilter').value, mfile;
	if (!filter) filter=/.*/;
	else {
		filter=filter.replace(/\s/g,'|');
		filter=filter.replace(/\./g,'\\.');
		filter=filter.replace(/\*/g,'.*');
		filter=filter.replace(/\?/g,'.');
		filter=new RegExp("^("+filter+")$","i");
	}
	while(files.hasMoreElements()){
		var file = files.getNext();
		file.QueryInterface(Components.interfaces.nsIFile);
		if (file.isFile()&&filter.test(file.leafName)) {
			mfile=new mfuFile(file);
			mfile.fieldname=tprofile.namingTemplate.replace(/%d/,n);
			mfuFileTreeView.insertItem(mfile);
			n++;
		}
	}
}

function mfuAddFiles() {
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	fp.init(window, "Choose files for upload", Components.interfaces.nsIFilePicker.modeOpenMultiple);
	var res = fp.show();
	if (res == Components.interfaces.nsIFilePicker.returnOK) mfuChooseAndShowFiles(fp.files);
}

function mfuAddFolder() {
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	fp.init(window, "Choose folder with files for upload", Components.interfaces.nsIFilePicker.modeGetFolder);
	var res = fp.show();
	if (res == Components.interfaces.nsIFilePicker.returnOK) {
		var file = Components.classes["@mozilla.org/file/local;1"]
           .createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(fp.file.path);
		mfuChooseAndShowFiles(file.directoryEntries);
	}
}

function mfuUploadSelected() {
	var str="", url=document.getElementById('uploadurl').value, aform;
	if (!/^https?:\/\/[^\.]+(?:\..+)?$/.test(url)) {alert ('Invalid URL!'); return;}
	aform=new mfuAjaxForm();
	for (var i in mfuFileTreeView.files) if (mfuFileTreeView.files[i].choose) aform.addElement(mfuFileTreeView.files[i].fieldname,'file',mfuFileTreeView.files[i].path);
	for (var i in tprofile.fields) {
		var f=tprofile.fields[i];
		aform.addElement(f.name,'text',f.value);
	}
	aform.action=url
	document.getElementById('ulfolder').disabled=true;
	var res=aform.submit(mfuUploadResult);
}

function mfuUploadResult(result, text) {
	document.getElementById('ulfolder').disabled=false;
	if (result) {
		mfuFileTreeView.updateSelectedStatus(1);
		alert ("Request succeed! Server return:\n"+text);
	}
	else alert ("Error occurred: "+text);
}

function mfuLockToPage(lock) {
	lock=lock?true:false;
	tprofile.lockUrl=lock;
	document.getElementById('uploadurl').disabled=lock;
	if (lock) mfuGetCurrent();
}

function mfuShowNaming() {
	var arg={template:tprofile.namingTemplate,firstN:tprofile.namingFirstN},win = window.openDialog("chrome://uploader/content/naming.xul",
		"Additional Fields","chrome,centerscreen,modal",arg);
	tprofile.namingTemplate=arg.template;
	tprofile.namingFirstN=arg.firstN;
}

var mfuStream={
	fileInput:function () {
		return Components.classes["@mozilla.org/network/file-input-stream;1"]
			.createInstance(Components.interfaces.nsIFileInputStream);
	},

	bufferedInput:function () {
		return Components.classes["@mozilla.org/network/buffered-input-stream;1"]
			.createInstance(Components.interfaces.nsIBufferedInputStream);
	},

	stringInput:function () {
		return Components.classes["@mozilla.org/io/string-input-stream;1"]
			.createInstance(Components.interfaces.nsIStringInputStream);
	},

	multiplexInput:function () {
		return Components.classes["@mozilla.org/io/multiplex-input-stream;1"]
			.createInstance(Components.interfaces.nsIMultiplexInputStream);
	}
}

function mfuAjaxFormElement(name,type,value){
	this.type=type;
	this.name=name;
	this.value=value;
	if (type=='file') {
		this.file=(typeof(value)=='string')?this.getFileOnPath(value):value;
		if (!this.file.isFile()||!this.file.fileSize) return;
		this.mime=this.getFileMime(this.file);
	} else {
		this.mime='plain/text';
	}
	this.created=true;
}

mfuAjaxFormElement.prototype={
	getFileMime:function (f) {
		var ext,mime;
		try {
			ext = Components.classes["@mozilla.org/mime;1"]
				.createInstance(Components.interfaces.nsIMIMEService);
			mime=ext.getTypeFromFile(f);
		} catch(e) {mime='application/octet-stream';}
		return mime;
	},
	getFileOnPath:function (p){
		var file;
		try {
			file = Components.classes["@mozilla.org/file/local;1"]
				.createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(p);
		} catch(e) {file=false;}
		return file;
	},
	getPostData:function (mp,boundary) {
		var data='';
		if (mp) {
			var streams=[];
			boundary='--'+boundary;
			switch (this.type) {
				case 'file':
					this.streamSize=0;
					streams[0]=mfuStream.stringInput();
					data = boundary+'\n';
					data += 'Content-Disposition: form-data; name="'+this.name+'"; filename="'+this.file.leafName+'"\n';
					data += 'Content-Type: '+this.mime+'\n\n';
					streams[0].setData(data, data.length);
					this.streamSize+=data.length;

					streams[1] = mfuStream.fileInput();
					streams[1].init(this.file, 0x01, 0444, null);
					this.streamSize+=this.file.fileSize;

					streams[2]=mfuStream.stringInput();
					data = '\n'+boundary+"\n";
					streams[2].setData(data, data.length);
					this.streamSize+=data.length;
					break;

				case 'text':
				case 'password':
				case 'hidden':
				case 'submit':
				case 'radio':
				case 'checkbox':
					data=boundary + '\n'
					+ 'Content-Disposition: form-data; name="'+this.name+'"' + '\n\n'
					+ this.value + '\n\n'
					+ boundary + '\n';
					streams[0]=mfuStream.stringInput();
					streams[0].setData(data, data.length);
					this.streamSize=data.length;
					break;
				default:
					this.streamSize=0;
					break;
			}
			return streams;
		} else {
			return this.name+"="+encodeURI(this.value);
		}
	}
}

function mfuAjaxForm(form) {
	this.enctype='application/x-www-form-urlencoded';
	this.boundary='fnj48vhemg73jg';
	this.elements=[];
	this.bufferSize=16384;
	this.action='';
	if (form) {
		if (form instanceof String) form=document.getElementById(form);
		if (!form.elements||form.method=='get') return;
		for (var i = 0; i < form.elements.length; i++) {
			var e=form.elements[i];
			this.addElement(e);
		}
		this.enctype=form.enctype;
		this.method=form.method;
		this.action=form.action;
	}
}

mfuAjaxForm.prototype={
	submit:function(callback) {
		this.callback=callback;
		var size=0,mp=this.enctype=='multipart/form-data',outStream;

		if (mp) {
			var stream=mfuStream.multiplexInput(),streams;
			for (var i in this.elements) {
				var streams=this.elements[i].getPostData(mp,this.boundary);
				size+=this.elements[i].streamSize;
				for (var j in streams) stream.appendStream(streams[j]);
			}
			outStream = mfuStream.bufferedInput();
			outStream.init(stream, this.bufferSize);
		} else {
			var data=[];
			outStream=mfuStream.stringInput();
			for (var i in this.elements) data.push(this.elements[i].getPostData(mp));
			data=data.join("&");
			outStream.setData(data, data.length);
			size=data.length;
		}

		var xmlhttpUpload = new XMLHttpRequest(),fob=this;
		this.req=xmlhttpUpload;
		xmlhttpUpload.onreadystatechange=function() { fob.readyStateChange() }
		xmlhttpUpload.open("POST", this.action, true);
		xmlhttpUpload.overrideMimeType('text/XML;charset=windows-1251');
		dump ('Open URL: '+this.action+"\n");
		//xmlhttpUpload.open("GET", serverUrl, true);
		xmlhttpUpload.setRequestHeader("Content-length", size);
		dump ('Content length: '+size+"\n");
		var ct=(mp?(this.enctype+'; boundary="'+this.boundary+'"'):this.enctype);
		dump ('Content type: '+ct+"\n");
		xmlhttpUpload.setRequestHeader("Content-type", ct);
		if (!mp) dump ('sending: '+data+'\n');
		xmlhttpUpload.send(outStream);
		dump ('sended\n');
	},
	readyStateChange:function () {
		dump ('ready state: '+this.req.readyState+"\n");
		if (this.req.readyState == 4) {
			if(this.req.status == 200) {
				dump ("request succeed!\n");
				dump ('response text:\n'+this.req.responseText+"\n");
				if (this.callback) this.callback(true,this.req.responseText);
			} else {
				dump ('request error!'+"\n");
				dump (this.req.status+" "+this.req.statusText+"\n");
				if (this.callback) this.callback(false,this.req.status+" "+this.req.statusText);
			}
		}
	},
	addElement:function (name,type,value) {
		if (!name) return;
		if (typeof (name.tagName)=='string' && name.tagName.toUpperCase()=='INPUT') {
			if ((name.type=='radio'||name.type=='checkbox')&&!name.checked) return false;
			type=name.type; value=name.value; name=name.name;
		}
		if (type=='file') this.enctype='multipart/form-data';
		var e=new mfuAjaxFormElement(name,type,value);
		if (e.created) { this.elements.push(e); return true; }
		return false;
	}
}